SystemOrganization addCategory: #'JiffyCard-Core'!

ALApplication subclass: #JiffyCardApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JiffyCardApplication methodsFor: 'as yet unclassified' stamp: 'chc 6/6/2017 08:31'!
initializeLocator
	|topcard|
	topcard := JCTopCard new. 
	locator 
		at: ALPath root 
		put: (topcard addDecoration: (
			JCDelegation new delegate:
				 (ALCounterExample new owner: topcard))) asResource
		
	
	" (JCMessage new message: 'The Ghost In The Machine')"! !

ALComponentResource subclass: #JCHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !

Object subclass: #JCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCController subclass: #JCComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 12:41'!
addDecoration: newDecoration
	| dec |
dec _ self decoration.
newDecoration next: dec.
self decoration: newDecoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:05'!
decoration

	^ decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:05'!
decoration: anObject

	decoration := anObject! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 5/30/2017 12:46'!
initialize
	decoration := self! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 6/6/2017 08:27'!
removeDecoration
	| owner |
owner _ self decoration next.
self decoration: owner! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/26/2017 10:05'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCComponent subclass: #JCCounter
	instanceVariableNames: 'count parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCounter methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 20:34'!
answer
	parent main clearDelegate! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
count

	^ count! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
count: anObject

	count := anObject! !

!JCCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:16'!
initialize
	super initialize.
	count := 0.
	"delegate := BGHelloWorld new. "! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
parent

	^ parent! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
parent: anObject

	parent := anObject! !

!JCCounter methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 20:35'!
renderContentOn: html
	html a navigate: [count := count + 1]; with: '++'.
	html br.
	html span with: count asString.
	html br. 
	html a navigate: [count := count - 1]; with: '--'.
	html br.
	html a callback: [ self answer ]; with: 'Answer And Return'! !

JCComponent subclass: #JCHelloMars
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHelloMars methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:44'!
renderContentOn: html
	html p: 'Hello Mars'! !

JCComponent subclass: #JCHelloWorld
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 09:47'!
call
	 main delegate: (JCCounter new parent: self)! !

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 09:50'!
initialize
	main := JCHelloMars new! !

!JCHelloWorld methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:55'!
main

	^ main! !

!JCHelloWorld methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:55'!
main: anObject

	main := anObject! !

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 20:34'!
renderContentOn: html
	html div id: 'border'; with: [html p: 'Hello World'].
	html div id: 'border'; with: main.
	html a callback: [ self call ]; with: 'Next Delegate'! !

JCComponent subclass: #JCTopCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCTopCard methodsFor: 'converting' stamp: 'chc 5/30/2017 09:48'!
asResource
	^ JCHtmlResource component: self! !

!JCTopCard methodsFor: 'rendering' stamp: 'chc 5/30/2017 12:37'!
renderBodyOn: html
	html div
		with: [decoration renderOn: html]! !

!JCTopCard methodsFor: 'rendering' stamp: 'chc 5/30/2017 12:36'!
renderContentOn: html
	html p: 'Hello TopCard'! !

!JCTopCard methodsFor: 'rendering' stamp: 'chc 5/30/2017 09:59'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'JiffyCard'.
			 html style: 
				'#border {
					border: thin solid #aaa;
					margin-left: 8px;
					margin-right: 8 px;}'].
	html body: [ self renderBodyOn: html ] ]! !

!JCController methodsFor: 'rendering' stamp: 'chc 5/30/2017 12:51'!
renderOn: html
	"( self respondsTo: #decoration)
		ifTrue: [  self decoration renderContentOn: html   ]
		ifFalse: [ " self renderContentOn: html   " ]"! !

JCController subclass: #JCDecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next

	^ next! !

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next: anObject

	next := anObject! !

!JCDecoration methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:10'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCDecoration subclass: #JCDelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDelegation commentStamp: 'chc 5/30/2017 13:31' prior: 0!
This is a different kind of decoration. Instead of adding content or a window, which will pass on to the next decoration or the owner in the #next ivar. There is a component in the delegate ivar that replaces the original owner component. When this decoration is removed the original owner re-renders. 

It needs to go one step further. The delegate needs to be passed a self delegate reference (see Kent Beck "Smalltalk Best Practices") so that the component can have an anchor that can reach this decoration to send #remove. !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate

	^ delegate! !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate: anObject

	delegate := anObject! !

!JCDelegation methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 13:21'!
renderContentOn: html 
	html render: delegate! !

JCDecoration subclass: #JCMessage
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCMessage methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:26'!
message: anObject

	message := anObject! !

!JCMessage methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 13:26'!
renderContentOn: html
	html p: message.
	next renderContentOn: html ! !
